-- Tests for charP.cpkg
Package $apcocoa/ts/charP


Define Initialize()
EndDefine;


--GBasis over Z/2Z
Define TestCharP01()

TestRing::=ZZ[x,y,z];

Using TestRing Do
  Result:=CharP.GBasisF2(Ideal([x-y^2,x^2+xy,y^3]) );
  Expected:=[y^2 + x, x^2, xy];
  $apcocoa/ts/assert.AssertEqualsExact(Result, Expected, "TODO: Some error message!");
EndUsing;

EndDefine;


--GBasis over Z/256Z
Define TestCharP02()

TestRing::=ZZ[x,y,z];

Using TestRing Do
  Result:=CharP.GBasisF256(Ideal([x-y^2,x^2+xy,y^3]) );
  Expected:=[y^2 + 144x, x^2, xy];
  $apcocoa/ts/assert.AssertEqualsExact(Result, Expected, "TODO: Some error message!");
EndUsing;

EndDefine;


--GBasis over Z/1024Z
Define TestCharP03()

TestRing::=ZZ[x,y,z];

Using TestRing Do
  Result:=CharP.GBasisF1024(Ideal([x-y^2,x^2+xy,y^3]) );
  Expected:=[y^2 + 218x, x^2, xy];
  $apcocoa/ts/assert.AssertEqualsExact(Result, Expected, "TODO: Some error message!");
EndUsing;

EndDefine;




-- Solving over Z/2Z
Define TestCharP04()

TestRing::=Z/(2)[x[1..4]];

Using TestRing Do
  F:=[
    x[1]x[2] + x[2]x[3] + x[2]x[4] + x[3]x[4] + x[1] + x[3] + 1, 
    x[1]x[2] + x[1]x[3] + x[1]x[4] + x[3]x[4] + x[2] + x[3] + 1, 
    x[1]x[2] + x[1]x[3] + x[2]x[3] + x[3]x[4] + x[1] + x[4] + 1, 
    x[1]x[3] + x[2]x[3] + x[1]x[4] + x[2]x[4] + 1
    ];
  Result:=CharP.IMNLASolve(F);
  Expected:=[0, 1, 0, 1];
  $apcocoa/ts/assert.AssertEqualsExact(Result, Expected, "TODO: Some error message!");
EndUsing;

EndDefine;


-- Solving over Z/2Z
Define TestCharP05()

TestRing::=Z/(2)[x[1..4]];

Using TestRing Do
  F:=[
    x[1]x[2] + x[2]x[3] + x[2]x[4] + x[3]x[4] + x[1] + x[3] + 1, 
    x[1]x[2] + x[1]x[3] + x[1]x[4] + x[3]x[4] + x[2] + x[3] + 1, 
    x[1]x[2] + x[1]x[3] + x[2]x[3] + x[3]x[4] + x[1] + x[4] + 1, 
    x[1]x[3] + x[2]x[3] + x[1]x[4] + x[2]x[4] + 1
    ];
  Result:=CharP.MNLASolve(F);
  Expected:=[0, 1, 0, 1];
  $apcocoa/ts/assert.AssertEqualsExact(Result, Expected, "TODO: Some error message!");
EndUsing;

EndDefine;


-- Solving over Z/2Z
Define TestCharP06()

TestRing::=Z/(2)[x[1..4]];

Using TestRing Do
  F:=[
    x[1]x[2] + x[2]x[3] + x[2]x[4] + x[3]x[4] + x[1] + x[3] + 1, 
    x[1]x[2] + x[1]x[3] + x[1]x[4] + x[3]x[4] + x[2] + x[3] + 1, 
    x[1]x[2] + x[1]x[3] + x[2]x[3] + x[3]x[4] + x[1] + x[4] + 1, 
    x[1]x[3] + x[2]x[3] + x[1]x[4] + x[2]x[4] + 1
    ];
  Sparse:=True;
  Result:=CharP.NLASolve(F,Sparse);
  Expected:=[0, 1, 0, 1];
  $apcocoa/ts/assert.AssertEqualsExact(Result, Expected, "TODO: Some error message!");
EndUsing;

EndDefine;


-- Solving over Z/2Z
Define TestCharP07()

TestRing::=Z/(2)[x[1..4]];

Using TestRing Do
  F:=[
    x[1]x[2] + x[2]x[3] + x[2]x[4] + x[3]x[4] + x[1] + x[3] + 1, 
    x[1]x[2] + x[1]x[3] + x[1]x[4] + x[3]x[4] + x[2] + x[3] + 1, 
    x[1]x[2] + x[1]x[3] + x[2]x[3] + x[3]x[4] + x[1] + x[4] + 1, 
    x[1]x[3] + x[2]x[3] + x[1]x[4] + x[2]x[4] + 1
    ];
  Result:=CharP.XLSolve(F);
  Expected:=[0, 1, 0, 1];
  $apcocoa/ts/assert.AssertEqualsExact(Result, Expected, "TODO: Some error message!");
EndUsing;

EndDefine;


-- Solving over Z/2Z
Define TestCharP08()

TestRing::=Z/(2)[x[1..4]];

Using TestRing Do
  F:=[
    x[1]x[2] + x[2]x[3] + x[2]x[4] + x[3]x[4] + x[1] + x[3] + 1, 
    x[1]x[2] + x[1]x[3] + x[1]x[4] + x[3]x[4] + x[2] + x[3] + 1, 
    x[1]x[2] + x[1]x[3] + x[2]x[3] + x[3]x[4] + x[1] + x[4] + 1, 
    x[1]x[3] + x[2]x[3] + x[1]x[4] + x[2]x[4] + 1
    ];
  
  Result:=CharP.IMXLSolve(F);
  Expected:=[0, 1, 0, 1];
  $apcocoa/ts/assert.AssertEqualsExact(Result, Expected, "TODO: Some error message!");
EndUsing;

EndDefine;


EndPackage;